/* ƥȥǡեˤġ
 * shige
 * 10/14 1005
 * txt2snd.c
 *
 * $Id: txt2snd.c,v 1.1 2005-10-14 18:09:09+09 shige Exp $
 */
/* 1)	sox  .dat 鲻ǡѴ褦ʤΡ¿ͥ
 *	ȹԤˤб롣
 * 2)	ͥϼưȤեɿǤʤϥ
 *	ȸ롣
 * 3)	ƥեɤΥǡ -1.0 ~ 1.0 ΥǡȤ롣
 * 4)	Ϥɸϡfile = "-" ξɸϤϤ롣
 * 5)	'#', ';'  ǻϤޤԤϥȹԤȤߤʤ (';'  sox .dat ؤ
 *	ߴΤ)
 * 6)	ƥեɤڤܤ϶򡢤ޤϥ֡
 */
/* txt2snd ([option]) [file]
 * [option]:
 *   -au/wav/aiff: format (default: au)
 *   -s [n]: sampling rate (default: AU:8000, WAV/AIFF: 11025)
 *   -b [n]: bit length (default: AU:8, WAV/AIFF:16)
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "common.h"

#define Maxbuff 8192
#define Maxchannels 20
#define Minsmplrate 100
#define Maxsmplrate 200000

#define Default_AU_smpl 8000
#define Default_WAV_smpl 11025
#define Default_AIFF_smpl 11025
#define Default_AU_bit 8 /* fix */
#define Default_WAV_bit 16
#define Default_AIFF_bit 16

#define DelimitStr " \t"
#define isCommentHead(c) ((c)=='#'||(c)==';')

int main(int argc,char *argv[]);
int txt2snd(FILE *infile,FILE *outfile,SNDheader *snd,int channels,
	    double chdata[],int format);
int getchannels(FILE *infile,double chdata[]);
int getarg(int argc,char **argv,SNDheader *Snd,int *oform,int *channels,
	   double chdata[],FILE **Infile);
int countlines(FILE **Infile);
int setsndheader(SNDheader *Snd,int oform,int ch,int smpl,int bit,int dlen);
void usage(int ret);

int main(int argc,char *argv[])
{
    FILE *infile,*outfile=stdout;
    SNDheader snd;
    int ret,format,channels;
    double chdata[Maxchannels];
    
    if((ret=getarg(argc,argv,&snd,&format,&channels,chdata,&infile))<=0){
	usage(ret); return -ret;
    }
    putallSNDheader(outfile,&snd,1,format);
    if((ret=txt2snd(infile,outfile,&snd,channels,chdata,format))<0)
      return 10-ret;
    else return 0;
}

int txt2snd(FILE *infile,FILE *outfile,SNDheader *snd,int channels,
	    double chdata[],int format)
{
    int j,ch,bs,blocks;

    for(j=1;j<=channels;j++)
      SNDput1chleveldata(outfile,chdata[j-1],snd,format);
    while((ch=getchannels(infile,chdata))!=0){
	if(ch<0) return ch;
	if(ch!=channels) return -10;
	for(j=1;j<=channels;j++)
	  SNDput1chleveldata(outfile,chdata[j-1],snd,format);
    }
    bs=SNDblocksize(snd,format)/channels;
    blocks=SNDblocks(snd,format);
    if(format!=E_AU && bs%2 && blocks%2) fputc(0,outfile);
    return 0;
}


int getchannels(FILE *infile,double chdata[])
{
#if 0
    static int channels=0;
#endif
    int j,ch;
    char *s,buff[Maxbuff];
    double x;

    do{
	if(fgets(buff,Maxbuff,infile)==NULL) return 0; /* λ */
	if((j=strlen(buff))==Maxbuff-1 && buff[Maxbuff-2]!='\n') return -2;
	/* Too long line exists. */
	buff[j-1]='\0';
    }while(isCommentHead(buff[0]));
    ch=0;
    s=strtok(buff,DelimitStr);
    do{
	if(++ch>Maxchannels) return -3; /* Too many channels */
        if((x=atof(s))<-1.0 || x>1.0) return -4; /* unwanted value */
	chdata[ch-1]=x;
    }while((s=strtok(NULL,DelimitStr))!=NULL);
#if 0
    if(channels==0) channels=ch;
    else if(channels!=ch) return -5;  /* unwanted fields */
#endif
    return ch;
}


int getarg(int argc,char **argv,SNDheader *Snd,int *oform,int *channels,
	   double chdata[],FILE **Infile)
{
    int smpl=-1,bit=-1,ret;
    int blocks;

    *oform=E_AU;
    while(--argc>0){
	if(**(++argv)=='-'){
	    switch(*(++*argv)){
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 's':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((smpl=atoi(*argv))<=Minsmplrate || smpl>=Maxsmplrate){
		    fprintf(stderr,"Not correct s value (%s).\n",*argv);
		    return -11;
		}
		break;
	    case 'b':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((bit=atoi(*argv))!=8 && bit!=16){
		    fprintf(stderr,"Not correct b value (%s).\n",*argv);
		    return -12;
		}
		break;
	    case 'a':
	    case 'w':
		if(!strcmp(*argv,"au")) *oform=E_AU;
		else if(!strcmp(*argv,"wav")) *oform=E_WAV;
		else if(!strcmp(*argv,"aiff")) *oform=E_AIFF;
		else{
		    fprintf(stderr,"Unknown option (%s)\n",*argv);
		    return -14;
		}
	    case '\0': break;
	    default: return -6;
	    }
	    if(**argv=='\0'){ --*argv; break; }
	}
	else break;
    }
    if(argc>1){
#ifdef DEBUG1
	fprintf(stderr,"DEBUG1: %d\n",argc);
#endif
	return -7;
    }
    /* ¿ʬ -  test  */
    if(argc==0 || !strcmp(*argv,"-")) *Infile=stdin;
    else if((*Infile=fopen(*argv,"r"))==NULL){
	fprintf(stderr,"File [%s] open error.\n",*argv);
	return -8;
    }
    if(*oform==E_AU && bit>0 && bit!=8) return -9;
    if((blocks=countlines(Infile))<=0) return -10;
    if((*channels=getchannels(*Infile,chdata))<=0) return -20+*channels;
    if((ret=setsndheader(Snd,*oform,*channels,smpl,bit,blocks))<0) 
      return ret-30;
    return 1;
}

int countlines(FILE **Infile)
{
    char buff[Maxbuff];
    FILE *tmpf;
    int count=0;

    if(*Infile==stdin && (tmpf=tmpfile())==NULL) return -1;
    while(fgets(buff,Maxbuff,*Infile)!=NULL){
	if(strlen(buff)==Maxbuff-1 && buff[Maxbuff-2]!='\n') return -2;
	/* Too long line exists. */
	if(!isCommentHead(buff[0])){
	    count++;
	    if(*Infile==stdin) fputs(buff,tmpf);
	}
    }
    if(*Infile==stdin) *Infile=tmpf;
    if(fseek(*Infile,0L,SEEK_SET)<0) return -3;
    return count;
}

int setsndheader(SNDheader *Snd,int oform,int ch,int smpl,int bit,int blocks)
{
    switch(oform){
    case E_AU:
	(Snd->au).channel=ch;
	(Snd->au).smplrate=(smpl<0)?Default_AU_smpl:smpl;
	(Snd->au).magic=sto4bytei(".snd");
	(Snd->au).fmcode=1;
	(Snd->au).hlen=32;
	(Snd->au).str=NULL;
	(Snd->au).datalen=blocks*(Snd->au).channel; 
	break;
    case E_WAV:
	(Snd->wav).channel=ch;
	(Snd->wav).smplrate=(smpl<0)?Default_WAV_smpl:smpl;
	(Snd->wav).bitpersmpl=(bit<0)?Default_WAV_bit:bit;
	(Snd->wav).blocksize=(Snd->wav).channel*(Snd->wav).bitpersmpl/8;
	(Snd->wav).bytepersec=(Snd->wav).blocksize*(Snd->wav).smplrate;
	(Snd->wav).fmcode=1;
	(Snd->wav).hlen=44;
	(Snd->wav).datalen=blocks*(Snd->wav).blocksize;
	break;
    case E_AIFF:
	(Snd->aiff).channel=ch;
	(Snd->aiff).bitpersmpl=(bit<0)?Default_AIFF_bit:bit;
	(Snd->aiff).hlen=44+IEEEExtendedBytes;
	(Snd->aiff).smplrate.x=(smpl<0)?Default_AIFF_smpl:smpl;
	ConvertToIeeeExtended((Snd->aiff).smplrate.x,(Snd->aiff).smplrate.s);
	(Snd->aiff).flamesize=(Snd->aiff).channel*(Snd->aiff).bitpersmpl/8;
	(Snd->aiff).flames=blocks;
	(Snd->aiff).datalen=blocks*(Snd->aiff).flamesize;
	break;
    default: return -1;
    }
    return 0;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: txt2snd ([option]) ([file])",
	"  [file]: ϥƥȥե (default: ɸ)",
	"  [option]:",
	"    -au/wav/aiff: ǡ (default: AU)",
	"    -s[n]: ץ󥰼ȿ (default: AU:8000, WAV/AIFF: 11025)",
	"    -b[n]: ̻Ҳӥåȿ (default: AU:8, WAV/AIFF:16)",
	" ",
	" [1] ϥե '-' ꤷ硢ޤϲꤷʤ",
	"     ɸϤˤʤ롣",
	" [2] ϥեγƹԤˤ 1 ġޤʣΡ-1.0 ~ 1.0 ϰ",
	"     μ¿¤ӡ餬ƥץ󥰻Υ٥ǡǤ",
	"     롣ʣޤϥֶڤ¤Ǥϡ",
	"     ƥͥΥạ̇̄ΤȤߤʤ",
	" [3] ͥϥǡ鼫ưΤǡ¾ιԤȹʤ",
	"     Υǡ¤Ǥϥ顼Ȥʤ롣",
	" [4] ǡԤΤ'#', ';' ǻϤޤԤϥȤȤߤʤ (';' ",
	"     sox  .dat ؤθߴΤ)",
	" [5] ƹԤƤΥեɤǡˤ뤿ᡢsox  .dat ",
	"     Υǡ򿩤碌 1 ͥܤΥǡǡ2 ",
	"     ͥܤΥǡǡȤʤ롣 sndchan ",
	"     sndchmix ǼФ롣",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n",ret);
#endif
    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
